<?php

namespace Drupal\Tests\password_policy_pwned\Unit;

use Drupal\password_policy_pwned\Plugin\PasswordConstraint\PasswordPnwed;
use Drupal\password_policy_pwned\PwnedPasswordsClientInterface;
use Drupal\Tests\UnitTestCase;

/**
 * Tests the pwned password plugin.
 *
 * @group password_policy_pwned
 * @coversDefaultClass \Drupal\password_policy_pwned\Plugin\PasswordConstraint\PasswordPnwed
 */
class PasswordPnwedTest extends UnitTestCase {

  /**
   * @covers ::validate
   */
  public function testPwned() {
    $pwnedClient = $this->prophesize(PwnedPasswordsClientInterface::class);
    $pwnedClient->getOccurrences('abnchsdu')->willReturn(1);
    $pwnedClient->getOccurrences('password')->willReturn(3730471);

    $pwned = new PasswordPnwed(['min_occurrences' => 2], NULL, [], $pwnedClient->reveal());
    $pwned->setStringTranslation($this->getStringTranslationStub());
    $this->assertTrue($pwned->validate('abnchsdu', NULL)->isValid());
    $this->assertFalse($pwned->validate('password', NULL)->isValid());
  }

}
